use crate::{
    util::pack::pack_u16,
    app::Invitation,
};

use super::Packet;

#[derive(Clone)]
pub struct PacketInviteListResponse {
    pub status:u16,
    pub records:Vec<Invitation>,
}
impl PacketInviteListResponse {
    pub fn new() -> Self
    {
        Self {
            status:0,
            records:Vec::new(),
        }
    }
}
impl Packet for PacketInviteListResponse {
    type Data = Self;

    fn encode(&self) -> Vec<u8>
    {
        let mut output = [
            pack_u16(self.status),
            pack_u16(self.records.len() as u16),
        ].concat();

        for record in &self.records {
            output.append(&mut [
                record.token.to_vec(),
            ].concat());
        }

        output
    }
}
